<?php
/**
*** @name protocols.php
**/

$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path . 'common.php';

$smarty->assign('section', 'protocols');

$tab = '';
if(!empty($_GET['tab']))
{
	$tab = $_GET['tab'];
}

try
{
    if($action == 'show')
    {
        if($tab == 'ssh')
        {
/*
            // Get main ssh conf file
            $mainConfSSH = getJsonConfFile(PLUGINS_CONF_FILES_DIR . DEFAULT_PROTOCOLS_CONF_FILES['ssh']);
            $mainConfSSH['fileName'] = DEFAULT_PROTOCOLS_CONF_FILES['ssh'];
            $smarty->assign('mainConfSSH', $mainConfSSH);

            // List users files
            $listConfSSH = array();
            $listFilesSSH = getFilesListByNameEnd(PLUGINS_CONF_FILES_DIR, '.ssh.conf', array(DEFAULT_PROTOCOLS_CONF_FILES['ssh']));
            foreach($listFilesSSH as $file)
            {
                $conf = getJsonConfFile(PLUGINS_CONF_FILES_DIR . $file);
                $conf['fileName'] = $file;
                $listConfSSH[] = $conf;
            }
            $smarty->assign('listConfSSH', $listConfSSH);
*/
            // Get ssh pub keys
            $listPubKeys = array();
            $listPubKeysFiles = getFilesListByNameEnd(GESA_SSH_KEYS_DIR, '.pub');
            foreach($listPubKeysFiles as $file)
            {
                $listPubKeys[$file] = trim(file_get_contents(GESA_SSH_KEYS_DIR . $file));
            }
            $smarty->assign('listPubKeys', $listPubKeys);
        }
        elseif($tab == 'powershell')
        {
            // Get main powershell conf file
            $mainConfPW = getJsonConfFile(PLUGINS_CONF_FILES_DIR . DEFAULT_PROTOCOLS_CONF_FILES['powershell']);
            $mainConfPW['fileName'] = DEFAULT_PROTOCOLS_CONF_FILES['powershell'];
            $smarty->assign('mainConfPW', $mainConfPW);

            // List users files
            $listConfPW = array();
            $listFilesPW = getFilesListByNameEnd(PLUGINS_CONF_FILES_DIR, '.pwsh.conf', array(DEFAULT_PROTOCOLS_CONF_FILES['powershell']));
            foreach($listFilesPW as $file)
            {
                $conf = getJsonConfFile(PLUGINS_CONF_FILES_DIR . $file);
                $conf['fileName'] = $file;
                $listConfPW[] = $conf;
            }
            $smarty->assign('listConfPW', $listConfPW);
        }
        elseif($tab == 'ipmi')
        {
            // Get main ipmi conf file
            $mainConfIPMI = getTxtConfFile(PLUGINS_CONF_FILES_DIR . DEFAULT_PROTOCOLS_CONF_FILES['ipmi'], ' ');
            $mainConfIPMI['fileName'] = DEFAULT_PROTOCOLS_CONF_FILES['ipmi'];
            if(in_array($mainConfIPMI['driver-type'], PROTOCOLS_CONF_AVAILABLE['ipmi']['versions']))
            {
                $mainConfIPMI['driver-type'] = array_search($mainConfIPMI['driver-type'], PROTOCOLS_CONF_AVAILABLE['ipmi']['versions']);
            }
            $smarty->assign('mainConfIPMI', $mainConfIPMI);

            // List users files
            $listConfIPMI = array();
            $listFilesIPMI = getFilesListByNameEnd(PLUGINS_CONF_FILES_DIR, '.ipmi.conf', array(DEFAULT_PROTOCOLS_CONF_FILES['ipmi']));
            foreach($listFilesIPMI as $file)
            {
                $conf = getTxtConfFile(PLUGINS_CONF_FILES_DIR . $file, ' ');
                $conf['fileName'] = $file;
                if(in_array($conf['driver-type'], PROTOCOLS_CONF_AVAILABLE['ipmi']['versions']))
                {
                    $conf['driver-type'] = array_search($conf['driver-type'], PROTOCOLS_CONF_AVAILABLE['ipmi']['versions']);
                }
                $listConfIPMI[] = $conf;
            }
            $smarty->assign('listConfIPMI', $listConfIPMI);

            $smarty->assign('listPriv', PROTOCOLS_CONF_AVAILABLE['ipmi']['privileges']);
            $smarty->assign('listVersions', PROTOCOLS_CONF_AVAILABLE['ipmi']['versions']);
        }
    }
}
catch(GesaException | Exception $e)
{
	$errors[] = $e->getMessage();
}
$smarty->assign('errors', $errors);
$smarty->assign('action', $action);
$smarty->assign('tab', $tab);
$smarty->assign('PLUGINS_CONF_FILES_DIR', PLUGINS_CONF_FILES_DIR);
$smarty->assign('GESA_SSH_KEYS_DIR', GESA_SSH_KEYS_DIR);

$smarty->display(TPL_PATH . 'protocols.html');

?>
