<?php
if(empty($lang) || !is_array($lang))
{
	$lang = array();
}
$lang = array_merge($lang, array(
	'WEB_TITLE' => 'Esia GESA',
	'EN' => 'English',
	'FR' => 'French',
	'HOME' => 'Home',
	'LOGIN' => 'Login',
	'LOGOUT' => 'Logout',
	'USER' => 'User',
	'PASSWORD' => 'Password',
	'OLD_PASSWORD' => 'Current password',
	'NEW_PASSWORD' => 'New password',
	'GESA_VIRTUAL_MACHINE' => 'VM',
	'LAST_REFRESH_TIME' => 'Last refresh time',
	'MENU_HOME' => 'Home',
	'MENU_INTERFACES' => 'Interfaces',
	'MENU_PROTOCOLS' => 'Protocols',
	'MENU_USERS' => 'User',
	'ADD' => 'Add',
	'MODIFY' => 'Modify',
	'DELETE' => 'Delete',
	'RETURN' => 'Return',
	'CANCEL' => 'Cancel',
	'VALIDATE' => 'Validate',
	'CONFIRM_PASSWORD' => 'Confirm password',
	'DEFAULT_LANGUAGE' => 'Default language',
	'LOCAL_ACCOUNT_PARAMS' => 'Local account parameters',
	'ERR_PASSWD_NOT_CONFIRMED' => 'The confirm password must be identical',
	'ERR_CURRENT_PASSWD_REQUIRED' => 'The current password is required',
	'ERR_SAVE_USER_LANG' => 'Unable to save user language',
	'PARAMS_UPDATE_SUCCESS' => 'Parameters have been updated successfully',
	'SECTION_INDEX_INFO' => 'Common Informations',
	'SECTION_INDEX_DIAG' => 'Diagnostic',
	'SECTION_INDEX_MAJ' => 'Updates',
	'SECTION_INDEX_IFACES' => 'Interfaces',
	'SECTION_IFACE_CONF' => 'Interface configuration',
	'SECTION_SSH_AUTH_FILES' => 'SSH authentication files',
	'SECTION_POWERSHELL_AUTH_FILES' => 'PowerShell authentication files',
	'SECTION_IPMI_AUTH_FILES' => 'IPMI authentication files',
	'IP_ADDR' => 'IP Address',
	'IP_ADDR_PUB' => 'Public IP Address',
	'IP_ADDR_LOCAL' => 'Local IP Address',
	'NETMASK' => 'Netmask',
	'GATEWAY' => 'Gateway',
	'SERIAL_NUMBER' => 'Serial number',
	'TYPE' => 'Type',
	'DNS' => 'DNS',
	'OS_VERSION' => 'OS version',
	'MODEL' => 'Model',
	'LINKED_SERVER' => 'Linked server',
	'SERVER_PORT_CONNECTION' => 'Connection port',
	'OK' => 'Ok',
	'FAILED' => 'Failed',
	'DNS_RESOLUTION' => 'DNS resolution',
	'INTERNET_ACCESS' => 'Internet access',
	'SERVER_CONNECTION' => 'Server connection',
	'ECATP_LINK' => 'ECATP link',
	'UPDATES' => 'Updates',
	'UPDATE' => 'Update',
	'LAST_UPDATE' => 'Last update',
	'DAILY_UPDATE_TIME' => 'Daily update time',
	'START' => 'Start',
	'END' => 'End',
	'PACKAGES' => 'Packages',
	'STATE' => 'State',
	'NAME' => 'Name',
	'VERSION' => 'Version',
	'DESCRIPTION' => 'Description',
	'AUTO_UPDATES_NOT_CONFIGURED' => 'Not configured',
	'UPDATE_NOW' => 'Update now',
	'MISSING_FILE' => 'File is missing',
	'UPDATE_IN_PROGRESS' => 'Update in progress…',
	'PLEASE_WAIT' => 'Please wait.',
	'UPDATE_CAN_TAKE_FEW_MIN' => 'The update may take a few minutes.',
	'UPDATE_COMPLETED' => 'Update completed',
	'LAST_PROCESS_LINE' => 'Last process line',
	'IF_INDEX' => 'If index',
	'IF_IN_OCTET' => 'Number of bytes received',
	'IF_OUT_OCTET' => 'Number of bytes sent',
	'IF_IN_ERROR' => 'Input errors (CRC)',
	'IF_OUT_ERROR' => 'Output errors',
	'SPEED' => 'Speed',
	'MTU' => 'MTU',
	'IFACE_ADD' => 'Add interface',
	'LABEL' => 'Label',
	'INTERFACE' => 'Interface',
	'INTERFACES' => 'Interfaces',
	'VLAN' => 'VLAN',
	'ERR_MISSING_IFACE_DATA' => 'Error: Missing interface data',
	'ERR_SAVE_IFACE_DATA' => 'Error: Unable to save interface configuration',
	'PARAMS_IFACE_ADD_SUCCESS' => 'The interface has been successfully added',
	'PARAMS_IFACE_UPDATE_SUCCESS' => 'The interface has been successfully modified',
	'PARAMS_IFACE_DELETE_SUCCESS' => 'The interface has been successfully deleted',
	'DELETE_IFACE' => 'Delete interface',
	'DELETE_IFACE_CONFIRM_MSG' => 'Do you want to delete this network interface ?',
	'ERR_SAVE_IFACE_DUPLICATION_INDEX' => 'Error: An interface is already configured on this index and VLAN',
	'SELECT_VALUE' => 'Select value',
	'SELECT_SEARCH' => 'Search',
	'SELECT_NO_RESULTS' => 'No results',
	'SELECT_INTERFACE' => 'Select interface',
	'SELECT_NO_INTERFACES_AVAILABLE' => 'No interface available',
	'FILE_NAME' => 'File name',
	'HOST' => 'Host',
	'PORT' => 'Port',
	'ACTIONS' => 'Actions',
	'ERR_COPY_FILE_PATH' => 'Error copying file path',
	'ERR_PROT_TYPE_MISSING' => 'Protocol type is missing',
	'ERR_PROT_WRONG_TYPE' => 'Protocol type unknown',
	'ERR_PROT_FILENAME_MISSING' => 'Config file name is missing',
	'ERR_PROT_FILENAME_EXISTS' => 'Config file name already exists',
	'ERR_CANNOT_SAVE_FILE' => 'Unable to save file',
	'ERR_CANNOT_DELETE_FILE' => 'Unable to delete file',
	'ERR_CANNOT_DELETE_DEFAULT_FILE' => 'Deleting the default configuration file is not allowed',
	'INFO' => 'Info',
	'INFO_FILES_LOCATED' => 'All files are located in',
	'INFO_HOST_PARAM_SERVICE_PRIOR' => 'If the host is specified in the service parameters (-H) on the Esia server, this service parameter will override the host defined in the configuration file.',
	'REBOOT' => 'Reboot',
	'REBOOT_GESA' => 'Reboot GESA',
	'REBOOT_GESA_CONFIRM_MSG' => 'Are you sure you want to reboot the GESA ?',
	'REBOOT_GESA_WARN_UNSAVED' => 'Unsaved configurations will be lost.',
	'REBOOT_GESA_WARN_INTERFACE' => 'The web interface may become unresponsive if the network settings of the management interface have been changed.',
	'REBOOT_COMPLETED' => 'Reboot completed',
	'ERR_REBOOT' => 'Reboot failed !',
	'ERR_SYSTEM' => 'System error',
	'ERR_CANNOT_UPDATE' => 'Update failed !',
	'TASK_COMPLETED_AFTER' => 'Task completed after',
	'MAX_TIMEOUT_EXCEEDED_AFTER' => 'Max timeout exceeded after',
	'GESA_RESTARTED_SUCCESS' => 'The GESA has restarted.',
	'ERR_REBOOT_FAILED' => 'Reboot failed.',
	'SECONDS' => 'seconds',
	'REBOOT_IN_PROGRESS' => 'Reboot in progress…',
	'PRIVILEGE' => 'Privilege',
	'DRIVER' => 'Driver',
	'DRIVER_VERSION' => 'Driver version',
	'ERR_UNKNOWN_PRIVILEGE' => 'Unknown privilege selected',
	'ERR_UNKNOWN_DRIVER' => 'Unknown privilege selected',
	'FETCHING_DATA' => 'Fetching data',
	'SSH_PUB_KEYS' => 'SSH public keys',
	'SSH_KEY' => 'SSH key',
	'STARTING' => 'Starting',
	'WARN_USER_UPDATE' => 'Warning, modifying the user password modifies the password of the web interface & SSH',
	'WARN_MAIN_MGMT_IFACE_UPDATE' => 'Warning, modifying this interface may result in loss of access to the web interface & SSH',
	'INTERFACE_IP_SWITCH_SUCCESS' => 'The web interface is available on the new IP.',
	'INTERFACE_IP_SWITCH_ERR' => 'The web interface is no longer accessible.',
	'INTERFACE_DHCP_RESTART_WEB' => 'Restart the web interface with the IP provided by the DHCP server.',
));
?>
