<?php
if(empty($lang) || !is_array($lang))
{
	$lang = array();
}
$lang = array_merge($lang, array(
	'WEB_TITLE' => 'Esia GESA',
	'EN' => 'Anglais',
	'FR' => 'Français',
	'HOME' => 'Accueil',
	'LOGIN' => 'Connexion',
	'LOGOUT' => 'Déconnexion',
	'USER' => 'Utilisateur',
	'PASSWORD' => 'Mot de passe',
	'OLD_PASSWORD' => 'Ancien mot de passe',
	'NEW_PASSWORD' => 'Nouveau mot de passe',
	'GESA_VIRTUAL_MACHINE' => 'VM',
	'LAST_REFRESH_TIME' => 'Heure du dernier rafraîchissement',
	'MENU_HOME' => 'Accueil',
	'MENU_INTERFACES' => 'Interfaces',
	'MENU_PROTOCOLS' => 'Protocoles',
	'MENU_USERS' => 'Utilisateur',
	'ADD' => 'Ajouter',
	'MODIFY' => 'Modifier',
	'DELETE' => 'Supprimer',
	'RETURN' => 'Retour',
	'CANCEL' => 'Annuler',
	'VALIDATE' => 'Valider',
	'CONFIRM_PASSWORD' => 'Confirmer le mot de passe',
	'DEFAULT_LANGUAGE' => 'Langue par défaut',
	'LOCAL_ACCOUNT_PARAMS' => 'Paramètres du compte local',
	'ERR_PASSWD_NOT_CONFIRMED' => 'Le mot de passe de confirmation doit être identique',
	'ERR_CURRENT_PASSWD_REQUIRED' => 'L\'ancien mot de passe est requis',
	'ERR_SAVE_USER_LANG' => 'Impossible d\'enregistrer la langue de l\'utilisateur',
	'PARAMS_UPDATE_SUCCESS' => 'Les paramètres ont été mis à jour avec succès',
	'SECTION_INDEX_INFO' => 'Informations Générales',
	'SECTION_INDEX_DIAG' => 'Diagnostique',
	'SECTION_INDEX_MAJ' => 'Mises à jour',
	'SECTION_INDEX_IFACES' => 'Interfaces',
	'SECTION_IFACE_CONF' => 'Configuration de l\'interface',
	'SECTION_SSH_AUTH_FILES' => 'Fichiers d\'authentification SSH',
	'SECTION_POWERSHELL_AUTH_FILES' => 'Fichiers d\'authentification PowerShell',
	'SECTION_IPMI_AUTH_FILES' => 'Fichiers d\'authentification IPMI',
	'IP_ADDR' => 'Adresse IP',
	'IP_ADDR_PUB' => 'Adresse IP publique',
	'IP_ADDR_LOCAL' => 'Adresse IP locale',
	'NETMASK' => 'Masque de sous-réseau',
	'GATEWAY' => 'Passerelle',
	'SERIAL_NUMBER' => 'Numéro de série',
	'TYPE' => 'Type',
	'DNS' => 'DNS',
	'OS_VERSION' => 'Version de l\'OS',
	'MODEL' => 'Modèle',
	'LINKED_SERVER' => 'Serveur lié',
	'SERVER_PORT_CONNECTION' => 'Port de connexion',
	'OK' => 'Ok',
	'FAILED' => 'Échoué',
	'DNS_RESOLUTION' => 'Résolution DNS',
	'INTERNET_ACCESS' => 'Accès internet',
	'SERVER_CONNECTION' => 'Connexion au serveur',
	'ECATP_LINK' => 'Liaison ECATP',
	'UPDATES' => 'Mises à jour',
	'UPDATE' => 'Mise à jour',
	'LAST_UPDATE' => 'Dernière mise à jour',
	'DAILY_UPDATE_TIME' => 'Heure de mise à jour journalière',
	'START' => 'Début',
	'END' => 'Fin',
	'PACKAGES' => 'Paquets',
	'STATE' => 'Status',
	'NAME' => 'Nom',
	'VERSION' => 'Version',
	'DESCRIPTION' => 'Description',
	'AUTO_UPDATES_NOT_CONFIGURED' => 'Pas configurées',
	'UPDATE_NOW' => 'Mettre à jour',
	'MISSING_FILE' => 'Fichier manquant',
	'UPDATE_IN_PROGRESS' => 'Mise à jour en cours…',
	'PLEASE_WAIT' => 'Veuillez patienter svp.',
	'UPDATE_CAN_TAKE_FEW_MIN' => 'La mise à jour peut durer quelques minutes.',
	'UPDATE_COMPLETED' => 'La mise à jour est terminée',
	'LAST_PROCESS_LINE' => 'Dernière ligne du process',
	'IF_INDEX' => 'If index',
	'IF_IN_OCTET' => 'Nombre d\'octets reçu',
	'IF_OUT_OCTET' => 'Nombre d\'octets envoyés',
	'IF_IN_ERROR' => 'Erreurs en entrée (CRC)',
	'IF_OUT_ERROR' => 'Erreurs en sortie',
	'SPEED' => 'Vitesse',
	'MTU' => 'MTU',
	'IFACE_ADD' => 'Ajouter une interface',
	'LABEL' => 'Label',
	'INTERFACE' => 'Interface',
	'INTERFACES' => 'Interfaces',
	'VLAN' => 'VLAN',
	'ERR_MISSING_IFACE_DATA' => 'Erreur: Données d\'interface manquantes',
	'ERR_SAVE_IFACE_DATA' => 'Erreur: Impossible d\'enregistré la configuration de l\'interface',
	'PARAMS_IFACE_ADD_SUCCESS' => 'L\'interface a été ajoutée avec succès',
	'PARAMS_IFACE_UPDATE_SUCCESS' => 'L\'interface a été modifiée avec succès',
	'PARAMS_IFACE_DELETE_SUCCESS' => 'L\'interface a été supprimée avec succès',
	'DELETE_IFACE' => 'Supprimer l\'interface',
	'DELETE_IFACE_CONFIRM_MSG' => 'Voulez-vous vraiment supprimer cette interface réseau ?',
	'ERR_SAVE_IFACE_DUPLICATION_INDEX' => 'Erreur: Une interface est déjà configurée sur cet index et VLAN',
	'SELECT_VALUE' => 'Sélectionnez une valeur',
	'SELECT_SEARCH' => 'Recherchez',
	'SELECT_NO_RESULTS' => 'Aucun résultat',
	'SELECT_INTERFACE' => 'Sélectionnez une interface',
	'SELECT_NO_INTERFACES_AVAILABLE' => 'Aucune interface disponible',
	'FILE_NAME' => 'Nom du fichier',
	'HOST' => 'Hôte',
	'PORT' => 'Port',
	'ACTIONS' => 'Actions',
	'ERR_COPY_FILE_PATH' => 'Erreur lors de la copie du chemin du fichier',
	'ERR_PROT_TYPE_MISSING' => 'Le type de protocole est manquant',
	'ERR_PROT_WRONG_TYPE' => 'Type de protocole inconnu',
	'ERR_PROT_FILENAME_MISSING' => 'Le nom du fichier de configuration est manquant',
	'ERR_PROT_FILENAME_EXISTS' => 'Un fichier existe déjà avec ce nom',
	'ERR_CANNOT_SAVE_FILE' => 'Impossible d\'enregistrer le fichier',
	'ERR_CANNOT_DELETE_FILE' => 'Impossible de supprimer le fichier',
	'ERR_CANNOT_DELETE_DEFAULT_FILE' => 'La suppression du fichier de configuration par défaut n\'est pas autorisée',
	'INFO' => 'Info',
	'INFO_FILES_LOCATED' => 'Tous les fichiers se trouvent dans',
	'INFO_HOST_PARAM_SERVICE_PRIOR' => 'Si l\'hôte est spécifié dans les paramètres de service (-H) sur le serveur Esia, ce paramètre de service remplacera l\'hôte défini dans le fichier de configuration.',
	'REBOOT' => 'Redémarrer',
	'REBOOT_GESA' => 'Redémarrer la GESA',
	'REBOOT_GESA_CONFIRM_MSG' => 'Êtes-vous certains de vouloir redémarrer la GESA ?',
	'REBOOT_GESA_WARN_UNSAVED' => 'Les configurations non sauvegardées seront perdues.',
	'REBOOT_GESA_WARN_INTERFACE' => 'L\'interface web peut ne plus répondre si les paramètres réseau de l\'interface de management ont été modifiés.',
	'REBOOT_COMPLETED' => 'Redémarrage terminer',
	'ERR_REBOOT' => 'Redémarrage impossible !',
	'ERR_SYSTEM' => 'Erreur système',
	'ERR_CANNOT_UPDATE' => 'Mise à jour impossible !',
	'TASK_COMPLETED_AFTER' => 'Tâche terminée après',
	'MAX_TIMEOUT_EXCEEDED_AFTER' => 'Délai maximal dépassé après',
	'GESA_RESTARTED_SUCCESS' => 'La GESA a redémarrée.',
	'ERR_REBOOT_FAILED' => 'Le redémarrage a échoué.',
	'SECONDS' => 'secondes',
	'REBOOT_IN_PROGRESS' => 'Reboot en cours…',
	'PRIVILEGE' => 'Privilège',
	'DRIVER' => 'Pilote',
	'DRIVER_VERSION' => 'Version du pilote',
	'ERR_UNKNOWN_PRIVILEGE' => 'Le privilège séléctionné est inconnu',
	'ERR_UNKNOWN_DRIVER' => 'La version du pilote séléctionné est inconnue',
	'FETCHING_DATA' => 'Récupération des données',
	'SSH_PUB_KEYS' => 'Clés publique SSH',
	'SSH_KEY' => 'Clé SSH',
	'STARTING' => 'Démarrage',
	'WARN_USER_UPDATE' => 'Attention, modifier le mot de passe de l\'utilisateur modifie le mot de passe de l\'interface web & SSH',
	'WARN_MAIN_MGMT_IFACE_UPDATE' => 'Attention, modifier cette interface peut engendrer une perte d\'accès à l\'interface web & SSH',
	'INTERFACE_IP_SWITCH_SUCCESS' => 'L\'interface web est diponnible sur la nouvelle IP.',
	'INTERFACE_IP_SWITCH_ERR' => 'L\'interface web n\'est pas accessible.',
	'INTERFACE_DHCP_RESTART_WEB' => 'Redémarrer l\'interface web avec l\'IP fournie par le serveur DHCP.',
));
?>
