// users.js

// Self called function to start on file include
(() => {
	document.addEventListener("DOMContentLoaded", () => {
		setSelect('#userLang'); // Create language selector
		updateUsers();
	});
})();

// Update user form
function updateUsers()
{
	$("#updateUsers").on('submit', async e => {
		e.preventDefault();

		try {
			const formData = getFormValues('updateUsers');

			const success = await ajaxPromiseJSON({
				url: 'display.php',
				data: {
					action: "updateUsers",
					...formData,
				},
			});

			setSessionMessage([], success);

			location.reload();
		} catch (err) {
			displayUserMessage(err);
		}
	});
}
